package LATMOS::Accounts::Task::Basessynchro;

use strict;
use warnings;
use base qw(LATMOS::Accounts::Task);
use LATMOS::Accounts;
use LATMOS::Accounts::Log;

sub run {
    my ($self) = @_;
    my $LA = LATMOS::Accounts->new($self->{config}, noacl => 1) or do {
        la_log LA_ERR, "Cannot instantiate LA";
        return 1;
    };

    if (my $mail = $LA->val($self->{syncname} || $LA->default_synchro_name, 'maillog')) {
        la_set_log(mail => $mail);
    }

    my $sync = $LA->create_synchro(
        $self->{syncname} || $LA->default_synchro_name,
        test     => $self->{test},
    ) or do {
       la_log LA_ERR, "cannot create sync object";
       return 2;
    };

    $sync->load_dest and do {
        la_log LA_ERR, "Cannot load destination";
        return 3;
    };

    $sync->process() or do {
        la_log LA_ERR, "Sync has failed\n";
        return 4;
    };
}

1;
